; Program to interpolate UW-Hybrid (RAQMS_global) netcdf files
; to flight track. 
;

common exchange,varname
; FRAPPE
cname=[$
'co']
nchem=n_elements(cname)
;
; V8.9 with flux limitor on tracer mixing in SSAS and additional variables in regridded files
;
moddir='/ships19/aqda/lenzen/FV3GFS.8.9.EXP.ivy.PROD.450/RO3.BOTH.PSSAS.NGAC.ZBOC1.198/C192/REGRID.0.5/'
;
; TROPOMI CO DA
;
moddir='/ships19/aqda/lenzen/FV3GFS.8.9.EXP.ivy.GSI.CO.450/O3.GSI.CO.218/C192/5DEGLL/'
obsdir='/ships19/aqda/bpierce/Satellite/TROPOMI/CO/October_2019_download/LoRes/'

;
openr,1,'tropomi_LoRes_co.fil'
nfiles=0l
readf,1,nfiles
for nf=0,nfiles-1 do begin
blank=''
readf,1,blank
;S5P_OFFL_L2__CO_____20190718T013647_20190718T031816_09118_01_010302_20190724T005615.nc
result=str_sep(blank,'.')
sfile=result(0)
;!psym=0
;map_set,/us,/continents,limit=[-90,-180,90,180],title=sfile
result=str_sep(blank,'_____')
syr=strmid(result(1),0,4)
smn=strmid(result(1),4,2)
sdy=strmid(result(1),6,2)
hrmnsc=strmid(result(1),9,6)
shr=strmid(hrmnsc,0,2)
smin=strmid(hrmnsc,2,2)
ssec=strmid(hrmnsc,4,2)
;2011070118
year=long(syr)
month=long(smn)
day=long(sdy)
hour=long(shr)
minute=long(smin)
second=long(ssec)

syr1=strmid(result(1),16,4)
smn1=strmid(result(1),20,2)
sdy1=strmid(result(1),22,2)
hrmnsc1=strmid(result(1),25,6)
shr1=strmid(hrmnsc1,0,2)
smin1=strmid(hrmnsc1,2,2)
ssec1=strmid(hrmnsc1,4,2)
;2011070118
year1=long(syr1)
month1=long(smn1)
day1=long(sdy1)
hour1=long(shr1)
minute1=long(smin1)
second1=long(ssec1)
if hour1 lt hour then hour1=hour1+24l
print,blank
jday0=julday(1l,1l,year,0l,0l,0l)
jday=julday(month,day,year,0l,0l,0l)-jday0+1.
print,jday
result=str_sep(string(jday),'.')
sjd=strtrim(result(0),2)
if jday lt 10 then sjd='00'+sjd
if jday lt 100 then sjd='0'+sjd
infile=blank
;
result=H5F_IS_HDF5(obsdir+infile)

yr=syr
mn=smn
dy=sdy
new_day=yr+mn+dy
yr=year
mn=month
dy=day
jday0=julday(1l,1l,long(yr),0l,0l,0l)-0.5
jday=julday(mn,dy,yr,0l,0l,0l)-0.5
;print,jday,yr,mn,dy
if result eq 1 then begin

; Open HDF5-based file
file_id=H5F_OPEN(obsdir+infile)
;
;result=H5_BROWSER(indir+infile)
;stop

;result=H5_PARSE(infile)
;help,result,/structure
;stop

;           0:   DETAILED_RESULTS
;           1:   GEOLOCATIONS
;           2:   INPUT_DATA
param4='/PRODUCT/'
param5='/SUPPORT_DATA/'
param6='/INPUT_DATA/'
g4_id = H5G_OPEN(file_id,param4+param5+param6)
dnum=H5G_GET_NMEMBERS(g4_id,param4+param5+param6)
;comment=H5G_GET_COMMENT(g4_id,param4)

dname=strarr(dnum)
for inum=0L,dnum-1L do begin
 dname(inum)=H5G_GET_MEMBER_NAME(g4_id,param4+param5+param6,inum)
; print,inum,';   ',dname(inum)
endfor
;           0;   instrument_configuration_identifier
;           1;   instrument_configuration_version
;           2;   scaled_small_pixel_variance
;           3;   surface_altitude
;           4;   surface_altitude_precision
;           5;   surface_classification
;           6;   surface_pressure
index=6
;print,''

;print,';--------------------------------;'
;print,'    Extracting ', dname(index)
;print,';--------------------------------;'

param5=param4+param5+param6+'/'+strtrim(dname(index),2)
d_id = H5D_OPEN(g4_id,param5)
surface_pressure=H5D_READ(d_id)

;print,strtrim(dname(index),2),': max=',max(surface_pressure),', min=',min(surface_pressure)
;help,surface_pressure
;print,''
;attr_num=H5A_GET_NUM_ATTRS(d_id)
;for inum=0L,attr_num-1L do begin
; attr_id=H5A_OPEN_IDX(d_id,inum)
; attr_name=H5A_GET_NAME(attr_id)
; attr=H5A_READ(attr_id)
;; print,'        ',attr_name,': ',attr
;endfor
;print,''

H5D_CLOSE,d_id

param4='/PRODUCT/'
g4_id = H5G_OPEN(file_id,param4)
dnum=H5G_GET_NMEMBERS(g4_id,param4)
;comment=H5G_GET_COMMENT(g4_id,param4)

dname=strarr(dnum)
for inum=0L,dnum-1L do begin
 dname(inum)=H5G_GET_MEMBER_NAME(g4_id,param4,inum)
; print,inum,':   ',dname(inum)
endfor
;stop
;           0:   SUPPORT_DATA
;           1:   carbonmonoxide_total_column
;           2:   carbonmonoxide_total_column_precision
;           3:   corner
;           4:   delta_time
;           5:   ground_pixel
;           6:   latitude
;           7:   layer
;           8:   longitude
;           9:   qa_value
;          10:   scanline
;          11:   time
;          12:   time_utc
index=1
;print,''

;print,';--------------------------------;'
;print,'    Extracting ', dname(index)
;print,';--------------------------------;'

param5=param4+'/'+strtrim(dname(index),2)
d_id = H5D_OPEN(g4_id,param5)
cocolumn=H5D_READ(d_id)

;print,strtrim(dname(index),2),': max=',max(cocolumn),', min=',min(cocolumn)
;help,latitude
;print,''
attr_num=H5A_GET_NUM_ATTRS(d_id)
for inum=0L,attr_num-1L do begin
 attr_id=H5A_OPEN_IDX(d_id,inum)
 attr_name=H5A_GET_NAME(attr_id)
 attr=H5A_READ(attr_id)
; print,'        ',attr_name,': ',attr
endfor
;print,''

H5D_CLOSE,d_id
index=2
;print,''

;print,';--------------------------------;'
;print,'    Extracting ', dname(index)
;print,';--------------------------------;'

param5=param4+'/'+strtrim(dname(index),2)
d_id = H5D_OPEN(g4_id,param5)
cocolumn_precision=H5D_READ(d_id)

;print,strtrim(dname(index),2),': max=',max(cocolumn_precision),', min=',min(cocolumn_precision)
;help,latitude
;print,''
attr_num=H5A_GET_NUM_ATTRS(d_id)
for inum=0L,attr_num-1L do begin
 attr_id=H5A_OPEN_IDX(d_id,inum)
 attr_name=H5A_GET_NAME(attr_id)
 attr=H5A_READ(attr_id)
; print,'        ',attr_name,': ',attr
endfor
;print,''

H5D_CLOSE,d_id
index=6
;print,''

;print,';--------------------------------;'
;print,'    Extracting ', dname(index)
;print,';--------------------------------;'

param5=param4+'/'+strtrim(dname(index),2)
d_id = H5D_OPEN(g4_id,param5)
latitude=H5D_READ(d_id)

;print,strtrim(dname(index),2),': max=',max(latitude),', min=',min(latitude)
;help,latitude
;print,''
attr_num=H5A_GET_NUM_ATTRS(d_id)
for inum=0L,attr_num-1L do begin
 attr_id=H5A_OPEN_IDX(d_id,inum)
 attr_name=H5A_GET_NAME(attr_id)
 attr=H5A_READ(attr_id)
; print,'        ',attr_name,': ',attr
endfor
;print,''

H5D_CLOSE,d_id
index=8
;print,''

;print,';--------------------------------;'
;print,'    Extracting ', dname(index)
;print,';--------------------------------;'

param5=param4+'/'+strtrim(dname(index),2)
d_id = H5D_OPEN(g4_id,param5)
longitude=H5D_READ(d_id)
;print,strtrim(dname(index),2),': max=',max(longitude),', min=',min(longitude)
;help,longitude
;result=size(longitude)
;print,result
;           2         450        3246           4     1460700
result=size(longitude)
nc0=result(1)
nr0=result(2)
;print,''
attr_num=H5A_GET_NUM_ATTRS(d_id)
for inum=0L,attr_num-1L do begin
 attr_id=H5A_OPEN_IDX(d_id,inum)
 attr_name=H5A_GET_NAME(attr_id)
 attr=H5A_READ(attr_id)
; print,'        ',attr_name,': ',attr
endfor
;print,''

H5D_CLOSE,d_id
index=9
;print,''

;print,';--------------------------------;'
;print,'    Extracting ', dname(index)
;print,';--------------------------------;'

param5=param4+'/'+strtrim(dname(index),2)
d_id = H5D_OPEN(g4_id,param5)
qa_value=H5D_READ(d_id)
qa_value=qa_value*0.01

;print,strtrim(dname(index),2),': max=',max(qa_value),', min=',min(qa_value)
;help,qa_value
;print,''
attr_num=H5A_GET_NUM_ATTRS(d_id)
for inum=0L,attr_num-1L do begin
 attr_id=H5A_OPEN_IDX(d_id,inum)
 attr_name=H5A_GET_NAME(attr_id)
 attr=H5A_READ(attr_id)
; print,'        ',attr_name,': ',attr
endfor
;print,''

H5D_CLOSE,d_id

index=12
;print,''

;print,';--------------------------------;'
;print,'    Extracting ', dname(index)
;print,';--------------------------------;'

param5=param4+'/'+strtrim(dname(index),2)
d_id = H5D_OPEN(g4_id,param5)
time_utc=H5D_READ(d_id)

;print,strtrim(dname(index),2),': max=',max(time_utc),', min=',min(time_utc)
;help,time_utc
;print,''
attr_num=H5A_GET_NUM_ATTRS(d_id)
for inum=0L,attr_num-1L do begin
 attr_id=H5A_OPEN_IDX(d_id,inum)
 attr_name=H5A_GET_NAME(attr_id)
 attr=H5A_READ(attr_id)
; print,'        ',attr_name,': ',attr
endfor
;print,''

H5D_CLOSE,d_id
param4='/PRODUCT/SUPPORT_DATA/DETAILED_RESULTS'
g4_id = H5G_OPEN(file_id,param4)
dnum=H5G_GET_NMEMBERS(g4_id,param4)
;comment=H5G_GET_COMMENT(g4_id,param4)

dname=strarr(dnum)
for inum=0L,dnum-1L do begin
 dname(inum)=H5G_GET_MEMBER_NAME(g4_id,param4,inum)
; print,inum,':   ',dname(inum)
endfor
;stop
;           0:   chi_square
;           1:   column_averaging_kernel
;           2:   degrees_of_freedom
;           3:   height_scattering_layer
;           4:   methane_strong_twoband_total_column
;           5:   methane_total_column_prefit
;           6:   methane_weak_twoband_total_column
;           7:   number_of_iterations
;           8:   number_of_spectral_points_in_retrieval
;           9:   pressure_levels
;          10:   processing_quality_flags
;          11:   scattering_optical_thickness_SWIR
;          12:   semiheavy_water_total_column
;          13:   semiheavy_water_total_column_precision
;          14:   surface_albedo_2325
;          15:   surface_albedo_2335
;          16:   water_strong_twoband_total_column
;          17:   water_total_column
;          18:   water_total_column_precision
;          19:   water_weak_twoband_total_column
;          20:   wavelength_calibration_offset

index=1
;print,''

;print,';--------------------------------;'
;print,'    Extracting ', dname(index)
;print,';--------------------------------;'

param5=param4+'/'+strtrim(dname(index),2)
d_id = H5D_OPEN(g4_id,param5)
columnak=H5D_READ(d_id)
result=size(columnak)
nl0=result(1)

;print,strtrim(dname(index),2),': max=',max(columnak),', min=',min(columnak)
;help,columnak
;print,''
attr_num=H5A_GET_NUM_ATTRS(d_id)
for inum=0L,attr_num-1L do begin
 attr_id=H5A_OPEN_IDX(d_id,inum)
 attr_name=H5A_GET_NAME(attr_id)
 attr=H5A_READ(attr_id)
; print,'        ',attr_name,': ',attr
endfor
;print,''

H5D_CLOSE,d_id
index=9
;print,''

;print,';--------------------------------;'
;print,'    Extracting ', dname(index)
;print,';--------------------------------;'

param5=param4+'/'+strtrim(dname(index),2)
d_id = H5D_OPEN(g4_id,param5)
pressure=H5D_READ(d_id)

;print,strtrim(dname(index),2),': max=',max(pressure),', min=',min(pressure)
pressure=pressure/100.
;print,''
attr_num=H5A_GET_NUM_ATTRS(d_id)
for inum=0L,attr_num-1L do begin
 attr_id=H5A_OPEN_IDX(d_id,inum)
 attr_name=H5A_GET_NAME(attr_id)
 attr=H5A_READ(attr_id)
; print,'        ',attr_name,': ',attr
endfor
;print,''

H5D_CLOSE,d_id

;S5P_OFFL_L2__CO_____20190718T013647_20190718T031816_09118_01_010302_20190724T005615.nc
  iyear=long(strmid(infile,20,4))
  imon=long(strmid(infile,24,2))
  iday=long(strmid(infile,26,2))
;print,iyear,imon,iday
decade=iyear-2000l
;time=reform(time(1,*))-(decade*1000l+imon*100l+iday*10l)
!psym=3
index=where(cocolumn ne 9.96921e+36 and qa_value ge 0.5)
;print,'good'
help,index
if index(0) ne -1 then cocolumn(index)=cocolumn(index)*6.02214e+19
index=where(cocolumn eq 9.96921e+36 or qa_value lt 0.5)
;print,'bad'
help,index
if index(0) ne -1 then cocolumn(index)=-999.
;print,max(cocolumn)
;        fill value 9.96921e+36
;        units: mol m-2
;        standard_name: troposphere_mole_content_of_nitrogen_dioxide
;        long_name: Tropospheric vertical column of nitrogen dioxide
;        coordinates: longitude latitude
;        ancillary_variables: 
;cocolumn_precision air_mass_factor_troposphere air_mass_factor_total averaging_kernel
;        multiplication_factor_to_convert_to_molecules_percm2:   6.02214e+19
;
;
;        units: 1
;        scale_factor:     0.0100000
;        add_offset:       0.00000
;        valid_min:    0
;        valid_max:  100
;        long_name: data quality value
;        comment: 
;A continuous quality descriptor, varying between 0 (no data) and 1 (full quality data). Recommend to ignore data with qa_value < 0.5
;
cocolumn1=-999.+0.*cocolumn
index=where(cocolumn ne -999.)
cocolumn1(index)=1.e-18*cocolumn(index)
cocolumn=cocolumn1




ndat=n_elements(time_utc)
lat=latitude
lon=longitude
time=0.*time_utc
  iyear=yr
  imon=mn
  iday=dy
  utcsec=hour*60l*60l+minute*60l+second+(hour1*60l*60l+minute1*60l+second1 - (hour*60l*60l+minute*60l+second))*findgen(ndat)/(1.*(ndat-1))
;print,'utcsec ',max(utcsec),min(utcsec)
;
; 2d utcsec
;
utcsec2d=0.*longitude
ndat=nr0
for jj=0,nr0-1 do begin
utcsec2d(*,jj)=utcsec(jj)
endfor
time=utcsec/(60.*60.)
nvalues=n_elements(time)
utchr=(time mod 1.)*24.
index=where(utchr-shift(utchr,-1) gt 0.)
if index(0) ne -1 and index(0) ne nvalues-1 then utchr(index(0)+1:nvalues-1)=utchr(index(0)+1:nvalues-1)+24.
Psurface=1000.
Second=utcsec
;S5P_OFFL_L2__CO_____20190718T013647_20190718T031816_09118_01_010302_20190724T005615.nc
  iyear=long(strmid(infile,20,4))
  imon=long(strmid(infile,24,2))
  iday=long(strmid(infile,26,2))
;print,utcsec(0),utcsec(nvalues-1)
  flight_start=julday(imon,iday,iyear,0.,0.,utcsec(0))
  flight_stop=julday(imon,iday,iyear,0.,0.,utcsec(nvalues-1))
  daynum=julday(imon,iday,iyear)-julday(1,0,iyear)
  xjday=float(daynum)
  jdaystart=daynum(0)
  daynum2=flight_stop-julday(1,0,iyear)
  jdaystop=round(daynum2)
;help,flight_start,flight_stop
;help,jdaystart,jdaystop
  caldat,flight_start,mn1,dy1,yr1,hr1,min1,sec1
  time1=float(hr1)+float(min1)/60.+sec1/3600.
  caldat,flight_stop,mn2,dy2,yr2,hr2,min2,sec2
  time2=float(hr2)+float(min2)/60.+sec2/3600.
;help,time1,time2
;Determine how many model files are needed
  hours=[0.,6.,12.,18.,24.]
  test1=where(hours le time1,c1)
  test2=where(hours ge time2,c2)
  nday=jdaystop-jdaystart+1 
  nmodper=1+round(nday)*4-(c1-1)-(c2-1)
  modfiles=strarr(nmodper)
  dynfiles=strarr(nmodper)
  thishour=long(round(hours(test1(c1-1))))
;  print,nmodper,' model files needed:'
  model_time=dblarr(nmodper)
;Build list of model filenames
  for i=0,nmodper-1 do begin
    modtime=julday(1,xjday,iyear,thishour,0,0)
    model_time(i)=(modtime-jday0-0.5)*24.*60.*60.
    model_time(i)=(model_time(i)/(24.*60.*60.)-long(model_time(i)/(24.*60.*60.)))*24.*60.*60.
if i gt 0 and (model_time(i) lt model_time(i-1)) then model_time(i)=model_time(i)+24.*60.*60.
    caldat,modtime,mn0,dy0,yr0,hr0,min0,sec0
    hh=round(float(hr0)+float(min0)/60.+sec0/3600.)
    syr=strtrim(yr0,2)
    smn=strtrim(mn0,2)
    if strlen(smn) eq 1 then smn='0'+smn
    sdy=strtrim(dy0,2)
    if strlen(sdy) eq 1 then sdy='0'+sdy
    shr=strtrim(hh,2)
    if strlen(shr) eq 1 then shr='0'+shr
; turn on if monthsubdirectories
;goto, nomonthsubdirectories
;Determine path (date subdirectory) to model files
    if hh ge 12 then begin
      dir='20'+strmid(syr,2,2)+smn+sdy+'12/'
;      print,dir
      ;if directory doesn't exist, we are in fx period and need to use latest directory
      test=findfile(moddir+dir)
      if test(0) eq '' then begin
        test=findfile(moddir)
        dirs=where(strpos(test,'19') ge 0)
        test=test(dirs)
        latest=test(n_elements(test)-1)
        dir=latest+'/'
      endif
    endif else begin
      dirtime=julday(1,xjday(0),2019,thishour-24,0,0)
      caldat,dirtime,mn3,dy3,yr3,hr3,min3,sec3
      hh3=round(float(hr3)+float(min3)/60.+sec3/3600.)
      syr3=strtrim(yr3,2)
      smn3=strtrim(mn3,2)
      if strlen(smn3) eq 1 then smn3='0'+smn3
      sdy3=strtrim(dy3,2)
      if strlen(sdy3) eq 1 then sdy3='0'+sdy3
      shr3=strtrim(hh3,2)
      if strlen(shr3) eq 1 then shr3='0'+shr3
      dir='20'+strmid(syr3,2,2)+smn3+sdy3+'12/'
;      print,dir
      ;if directory doesn't exist, we are in fx period and need to use latest directory
       test=findfile(moddir+dir)
      if test(0) eq '' then begin
        test=findfile(moddir)
        dirs=where(strpos(test,'2019') ge 0)
        test=test(dirs)
        latest=test(n_elements(test)-1)
        dir=latest+'/'
      endif
    endelse
; if date subdirectories exist
;tracer.2019070118.5deg.ll.nc
    modfiles(i)=moddir+'tracer.'+syr+smn+sdy+shr+'.5deg.ll.nc'
;    print,modfiles(i),dynfiles(i)
    thishour=thishour+6L
  endfor
print,modfiles
print,dynfiles
;goto, jumpit
; change this to satellite index
  itotal=nc0*nr0
  isave=-999+intarr(nc0,nr0) & jsave=isave & lsave=isave
  xfsave=-999+fltarr(nc0,nr0) & yfsave=xfsave & zfsave=xfsave & iisave=xfsave & jjsave=xfsave
  xsave=-999+fltarr(nc0,nr0) & ysave=fltarr(nc0,nr0)
; change this to satellite index
  cocount=nc0*nr0
  yco=latitude
  xco=longitude
  index=where(xco le 0.)
  if index(0) ne -1 then xco(index)=360.+xco(index)

!psym=3
  index=where(cocolumn ne -999.)
;  oplot,longitude(index),latitude(index)
  psfc_mod=0.*longitude
  zsfc_mod=0.*longitude
  sco=utcsec
;  sco=dblarr(nvalues)
;  for i=0l,nvalues-1l do begin
;;    actime=julday(1,xjday(i),2004,xhour(i),xmin(i),xsec(i))
;    actime=julday(imon,iday,iyear,0.,0.,utcsec(i))
;    sco(i)=actime
;  endfor

;
; interpolate to measurement position
;
;  print,' interpolating to measurement position '
;  print,' cocount =',cocount 
;
; C192 (0.5 degree) Grid
  nc=720L
  nr=360L
  nl=64L
  alon=0.25+0.5*findgen(nc)
  alat=-89.75+0.5*findgen(nr)
  alon0=alon
  alat0=alat
;
; Need to consider wrap longitude
  salon=shift(alon,-1)
  salon(nc-1)=360.25
  salat=shift(alat,-1)
;
; UWNMS grid is uniform lat/lon, so simple space interp.
;
  ifound=0L
;
; change this loop to be over satellite
  for jj=0l,nr0-1l do begin
  for ii=0L,nc0-1l do begin
   xp = xco(ii,jj)
   yp = yco(ii,jj)

    iloc=where(alon le xp and salon gt xp,cx)
    jloc=where(alat le yp and salat gt yp,cy)
    if cx ne 1 or cy ne 1 then begin
    ;print,'Unable to interpolate'
    isave(ii,jj)=-999
    jsave(ii,jj)=-999
    xfsave(ii,jj)=-999
    yfsave(ii,jj)=-999
    endif else begin
    iloc=iloc(0)
    jloc=jloc(0)
;
            isave(ii,jj)=iloc
            jsave(ii,jj)=jloc
            xfsave(ii,jj)=(xp-alon(iloc))/(salon(iloc)-alon(iloc))
            yfsave(ii,jj)=(yp-alat(jloc))/(salat(jloc)-alat(jloc))
            ifound=ifound+1L
;            oplot,[xp,xp],[yp,yp],color=125
    endelse
  endfor  ;ii loop
  endfor  ;jj loop

;
;Have position interpolating info, now read model files and interpolate
; in space and time
;

  curtain=fltarr(nl,nc0,nr0)
  pcurt=fltarr(nl,nc0,nr0)
  zcurt=fltarr(nl,nc0,nr0)
  dpcurt=fltarr(nl,nc0,nr0)
  dzcurt=fltarr(nl,nc0,nr0)
  thcurt=fltarr(nl,nc0,nr0)
  for itime=0,nmodper-1 do begin
    nleft=0 & left=[0L]
    nright=0 & right=[0L]
    if itime lt nmodper-1 then $
     right=where(sco ge model_time(itime) and $
                sco lt model_time(itime+1),nright)
    if itime gt 0 then $
     left=where(sco ge model_time(itime-1) and $
                sco lt model_time(itime),nleft)
;
    netcdf_file=modfiles(itime)
;    print,' reading from FV3GFS regridded file',netcdf_file
    nc_file_id=ncdf_open(netcdf_file,/nowrite)
glob_info=ncdf_inquire(nc_file_id)
;print,'number of dimensions ',glob_info.ndims
;print,'number of ;variables ',glob_info.nvars
;print,'number of attributes ',glob_info.ngatts

; get dimensions
;
for idim=0,glob_info.ndims-1 do begin
    ncdf_diminq,nc_file_id, idim, name, dim
;    print,'dimension ',idim,name,dim
    if name eq 'grid_xt' then nlon=dim
    if name eq 'grid_yt' then nlat=dim
    if name eq 'pfull' then nlev=dim
endfor
;dimension        0bnds           2
;dimension        1time           1
;dimension        2pfull          64
;dimension        3grid_yt         360
;dimension        4grid_xt         720
;dimension        5phalf          65
;
for ivar=0,glob_info.nvars-1 do begin
    result=ncdf_varinq(nc_file_id,ivar)
;    print,';variable ',ivar,result.name,result.datatype,result.ndims
endfor
;variable        0timeDOUBLE           1
;variable        1iminLONG           1
;variable        2imaxLONG           1
;variable        3jminLONG           1
;variable        4jmaxLONG           1
;variable        5grid_xtFLOAT           1
;variable        6grid_ytFLOAT           1
;variable        7grid_ztLONG           1
;variable        8sfcpFLOAT           3
;variable        9sfczFLOAT           3
;variable       10aodFLOAT           3
;variable       11aod_bcocFLOAT           3
;variable       12aoddustFLOAT           3
;variable       13aodssaltFLOAT           3
;variable       14aodsulfFLOAT           3
;variable       15zlwigrdFLOAT           3
;variable       16precFLOAT           3
;variable       17prelFLOAT           3
;variable       18qFLOAT           4
;variable       19dpmFLOAT           4
;variable       20pdashFLOAT           4
;variable       21potvortFLOAT           4
;variable       22zdashFLOAT           4
;variable       23coFLOAT           4
;variable       24bc1FLOAT           4
;variable       25bc2FLOAT           4
;variable       26oc1FLOAT           4
;variable       27oc2FLOAT           4
;variable       28lnoxFLOAT           4
;variable       29o3vmrFLOAT           4
;variable       30ch4FLOAT           4
;variable       31ch2oFLOAT           4
;variable       32hno3tFLOAT           4
;variable       33ext_totFLOAT           4
;variable       34ext_bcocFLOAT           4
;variable       35ext_dustFLOAT           4
;variable       36ext_seasFLOAT           4
;variable       37ext_sulfFLOAT           4
;variable       38dust1FLOAT           4
;variable       39dust2FLOAT           4
;variable       40dust3FLOAT           4
;variable       41dust4FLOAT           4
;variable       42dust5FLOAT           4
;variable       43seas1FLOAT           4
;variable       44seas2FLOAT           4
;variable       45seas3FLOAT           4
;variable       46seas4FLOAT           4
;variable       47seas5FLOAT           4
;variable       48jo1dFLOAT           4
;variable       49jnoFLOAT           4
;variable       50cot6hrFLOAT           4
;variable       51emcofireFLOAT           4
;variable       52sulfFLOAT           4
;variable       53noyFLOAT           4
;variable       54oxFLOAT           4
;variable       55thetaFLOAT           4
;variable       56inccoFLOAT           4
;variable       57no2FLOAT           4
;variable       58TFLOAT           4
;variable       59UFLOAT           4
;variable       60VFLOAT           4
;variable       61dzFLOAT           4
ncdf_varget,nc_file_id,'grid_xt',lon
ncdf_varget,nc_file_id,'grid_yt',lat
ncdf_varget,nc_file_id,'pdash',press
ncdf_varget,nc_file_id,'dpm',delp
ncdf_varget,nc_file_id,'dz',delz
ncdf_varget,nc_file_id,'q',q
ncdf_varget,nc_file_id,'T',t
ncdf_varget,nc_file_id,'U',u
ncdf_varget,nc_file_id,'V',v
ncdf_varget,nc_file_id,'o3vmr',o3mr
;                o3mr:long_name = "ozone mixing ratio" ;
;                o3mr:units = "kg/kg" ;
press=press/100.
delp=delp/100.
ncdf_varget,nc_file_id,'pdash',p
ncdf_varget,nc_file_id,'zdash',z
ncdf_varget,nc_file_id,'sfcp',psfc
ncdf_varget,nc_file_id,'theta',ttheta
ncdf_varget,nc_file_id,'co',co
;
; close netCDF file
;
    ncdf_close,nc_file_id
;
    for ilr=0,1 do begin
     if ilr eq 0 then begin
      count=nleft
      index=left
      print,'# points earlier than current uwhyb output file',count
     endif else begin
      count=nright
      index=right
      print,'# points later than current uwhyb output file',count
     endelse
     if count gt 0l then begin
     print,index(0l),index(count-1l)
      for nn=0l,count-1l do begin
      for ii=0,nc0-1 do begin
        n=index(nn)
        i=isave(ii,n)
        ip1=(i+1) mod nc   ;account for wrap longitude
        j=jsave(ii,n)
        xfac=xfsave(ii,n)
        yfac=yfsave(ii,n)
        if i ne -999 and j ne -999 then begin
          facij=(1.-xfac)*(1.-yfac)
          facijp1=(1.-xfac)*yfac
          facip1j=xfac*(1.-yfac)
          facip1jp1=xfac*yfac
          if ilr eq 0 then $
           tfac=(sco(n)-model_time(itime-1))/ $
                (model_time(itime)-model_time(itime-1)) $
          else $
           tfac=(model_time(itime+1)-sco(n))/ $
                (model_time(itime+1)-model_time(itime))
;          print,'time factor= ',tfac
            for l=0,nl-1 do begin
              colp=facij*  co(i,j,l)     + facijp1*  co(i,j+1,l)+ $
                   facip1j*co(ip1,j,l)   + facip1jp1*co(ip1,j+1,l)
; nearest neighbor
;PSFC            FLOAT     = Array[442, 265, 1, 49]
;NO2             FLOAT     = Array[442, 265, 35, 25]
              colp=co(i,j,l)
              curtain(l,ii,n)=curtain(l,ii,n)+tfac*colp

               colp=press(i,j,l)
               pcurt(l,ii,n)=pcurt(l,ii,n)+tfac*colp

               colp=z(i,j,l)
               zcurt(l,ii,n)=zcurt(l,ii,n)+tfac*colp

               colp=delp(i,j,l)
               dpcurt(l,ii,n)=dpcurt(l,ii,n)+tfac*colp

               colp=delz(i,j,l)
               dzcurt(l,ii,n)=dzcurt(l,ii,n)+tfac*colp

            endfor
        endif
      endfor ; ii loop
      endfor ; nn loop
     endif
    endfor
   endfor
!psym=3
;plots,xco,yco,color=255.*(reform(pcurt(0,*,*),nc0,nr0)-500.)/500.
curtain_dir='/ships19/aqda/bpierce/FIREX-AQ/FV3RAQMS_TROPOMI/Curtain/'
ofile=curtain_dir+sfile+'_co_mission.C192.v8.9.vertmix.plumerise.scale.aware.sas.flux.limited.regrid.LoRes.tropomi.da.dat'
;  help,nc0,nr0
;  help,utcsec2d
;  help,xco
;  help,yco
;  help,cocolumn
;  help,nl0,nc0,nr0
;  help,columnak
;  help,nl,nc0,nr0
;  help,pcurt
;  help,curtain
  openw,20,ofile,/f77
  writeu,20,nc0,nr0
  writeu,20,utcsec2d
  writeu,20,xco
  writeu,20,yco
  writeu,20,cocolumn
  writeu,20,nl0,nc0,nr0
  writeu,20,columnak
  writeu,20,pressure
  writeu,20,nl,nc0,nr0
  writeu,20,pcurt
  writeu,20,zcurt
  writeu,20,dpcurt
  writeu,20,dzcurt
  writeu,20,curtain
  close,20
jumpit:
endif
endfor  ;flight loop

end
