; Specify window size
nxpix=1000L
nypix=1000L

SETPLOT='ps'
SETPLOT='Z'
;read,'setplot?',setplot

if setplot eq 'Z' then begin
;-------------------------------------------
set_plot,'Z'
device,set_resolution=[nxpix,nypix],z_buffer=0
win_nx=!d.x_size
win_ny=!d.y_size

;--------------------------------------------
; Insert the main script
;--------------------------------------------
endif
if SETPLOT eq 'ps' then set_plot,'ps'
; set color table
  loadct,39
  !p.background=254.
  !p.color=255.
mcolor=byte(!p.color)
mcolor=fix(mcolor)
if mcolor eq 0 then mcolor=255
col1=mcolor
icmm1=mcolor-1
icmm2=mcolor-2
if setplot eq 'x' then begin
   lc=mcolor
   window,4,xsize=nxdim,ysize=nydim
   device,retain=2,decomposed=0
endif
; Specify window size
nxdim=1000L
nydim=1000L
yyyymmdd='20190722'
if setplot eq 'ps' then begin
   lc=0
   set_plot,'ps'
   xsize=nxdim/100.
   ysize=nydim/100.
   !p.font=0
   device,/landscape,bits=8,filename='tropomi_column_co_'+yyyymmdd+'.mollweide.ps'
   device,/color
   device,/inch,xoff=4.25-ysize/2.,yoff=5.5+xsize/2.,$
          xsize=xsize,ysize=ysize
   !p.charsize=1.
endif
!p.charsize=1
set_viewport,0,1,0,1
!type=2^5+2^6
plot,[0,1],[0,1],/nodata
polyfill,[0,1,1,0,0],[0,0,1,1,0],color=mcolor
set_viewport,.1,.9,.2,.9
MAP_SET,0,180,0,/mollweide,/noborder,/continents,/grid,latdel=30.,/noeras
;
indir='/ships19/aqda/bpierce/Satellite/TROPOMI/CO/October_2019_download/LoRes/'
;
openr,1,'tropomi.co.fil'
nfiles=0l
readf,1,nfiles
for nf=0,nfiles-1 do begin
blank=''
readf,1,blank
; no2 result=str_sep(blank,'____')
result=str_sep(blank,'_____')
syr=strmid(result(1),0,4)
smn=strmid(result(1),4,2)
sdy=strmid(result(1),6,2)
hrmnsc=strmid(result(1),9,6)
shr=strmid(hrmnsc,0,2)
smin=strmid(hrmnsc,2,2)
ssc=strmid(hrmnsc,4,2)
shr=shr+':'+smin+':'+ssc
;2011070118
year=long(syr)
month=long(smn)
day=long(sdy)
hour=long(hrmnsc)
print,blank
jday0=julday(1l,1l,year,0l,0l,0l)
jday=julday(month,day,year,0l,0l,0l)-jday0+1.
;print,jday
result=str_sep(string(jday),'.')
sjd=strtrim(result(0),2)
if jday lt 10 then sjd='00'+sjd
if jday lt 100 then sjd='0'+sjd
infile=blank
;
result=H5F_IS_HDF5(indir+infile)

if result eq 1 then begin

; Open HDF5-based file
file_id=H5F_OPEN(indir+infile)

;result=H5_BROWSER(infile)
;stop

;result=H5_PARSE(infile)
;help,result,/structure
;stop

;           0:   DETAILED_RESULTS
;           1:   GEOLOCATIONS
;           2:   INPUT_DATA
param4='/PRODUCT/'
g4_id = H5G_OPEN(file_id,param4)
dnum=H5G_GET_NMEMBERS(g4_id,param4)
;comment=H5G_GET_COMMENT(g4_id,param4)

dname=strarr(dnum)
for inum=0L,dnum-1L do begin
 dname(inum)=H5G_GET_MEMBER_NAME(g4_id,param4,inum)
 print,inum,':   ',dname(inum)
endfor
;           0:   SUPPORT_DATA
;           1:   carbonmonoxide_total_column
;           2:   carbonmonoxide_total_column_precision
;           3:   corner
;           4:   delta_time
;           5:   ground_pixel
;           6:   latitude
;           7:   layer
;           8:   longitude
;           9:   qa_value
;          10:   scanline
;          11:   time
;          12:   time_utc
index=6
print,''

print,';--------------------------------;'
print,'    Extracting ', dname(index)
print,';--------------------------------;'

param5=param4+'/'+strtrim(dname(index),2)
d_id = H5D_OPEN(g4_id,param5)
latitude=H5D_READ(d_id)

print,strtrim(dname(index),2),': max=',max(latitude),', min=',min(latitude)
help,latitude
print,''
attr_num=H5A_GET_NUM_ATTRS(d_id)
for inum=0L,attr_num-1L do begin
 attr_id=H5A_OPEN_IDX(d_id,inum)
 attr_name=H5A_GET_NAME(attr_id)
 attr=H5A_READ(attr_id)
; print,'        ',attr_name,': ',attr
endfor
print,''

H5D_CLOSE,d_id
index=8
print,''

print,';--------------------------------;'
print,'    Extracting ', dname(index)
print,';--------------------------------;'

param5=param4+'/'+strtrim(dname(index),2)
d_id = H5D_OPEN(g4_id,param5)
longitude=H5D_READ(d_id)

print,strtrim(dname(index),2),': max=',max(longitude),', min=',min(longitude)
help,longitude
print,''
attr_num=H5A_GET_NUM_ATTRS(d_id)
for inum=0L,attr_num-1L do begin
 attr_id=H5A_OPEN_IDX(d_id,inum)
 attr_name=H5A_GET_NAME(attr_id)
 attr=H5A_READ(attr_id)
; print,'        ',attr_name,': ',attr
endfor
print,''

H5D_CLOSE,d_id
index=1
print,''

print,';--------------------------------;'
print,'    Extracting ', dname(index)
print,';--------------------------------;'

param5=param4+'/'+strtrim(dname(index),2)
d_id = H5D_OPEN(g4_id,param5)
carbonmonoxide_total_column=H5D_READ(d_id)

print,strtrim(dname(index),2),': max=',max(carbonmonoxide_total_column),', min=',min(carbonmonoxide_total_column)
help,carbonmonoxide_total_column
print,''
attr_num=H5A_GET_NUM_ATTRS(d_id)
for inum=0L,attr_num-1L do begin
 attr_id=H5A_OPEN_IDX(d_id,inum)
 attr_name=H5A_GET_NAME(attr_id)
 attr=H5A_READ(attr_id)
; print,'        ',attr_name,': ',attr
endfor
print,''
H5D_CLOSE,d_id
index=9
print,''

print,';--------------------------------;'
print,'    Extracting ', dname(index)
print,';--------------------------------;'

param5=param4+'/'+strtrim(dname(index),2)
d_id = H5D_OPEN(g4_id,param5)
qa_value=H5D_READ(d_id)

print,strtrim(dname(index),2),': max=',max(qa_value),', min=',min(qa_value)
help,qa_value
print,''
attr_num=H5A_GET_NUM_ATTRS(d_id)
for inum=0L,attr_num-1L do begin
 attr_id=H5A_OPEN_IDX(d_id,inum)
 attr_name=H5A_GET_NAME(attr_id)
 attr=H5A_READ(attr_id)
; print,'        ',attr_name,': ',attr
endfor
print,''
H5D_CLOSE,d_id
param4='/PRODUCT/SUPPORT_DATA/DETAILED_RESULTS'
g4_id = H5G_OPEN(file_id,param4)
dnum=H5G_GET_NMEMBERS(g4_id,param4)
;comment=H5G_GET_COMMENT(g4_id,param4)

dname=strarr(dnum)
for inum=0L,dnum-1L do begin
 dname(inum)=H5G_GET_MEMBER_NAME(g4_id,param4,inum)
 print,inum,':   ',dname(inum)
endfor
;           0:   chi_square
;           1:   column_averaging_kernel
;           2:   degrees_of_freedom
;           3:   height_scattering_layer
;           4:   methane_strong_twoband_total_column
;           5:   methane_total_column_prefit
;           6:   methane_weak_twoband_total_column
;           7:   number_of_iterations
;           8:   number_of_spectral_points_in_retrieval
;           9:   pressure_levels
;          10:   processing_quality_flags
;          11:   scattering_optical_thickness_SWIR
;          12:   semiheavy_water_total_column
;          13:   semiheavy_water_total_column_precision
;          14:   surface_albedo_2325
;          15:   surface_albedo_2335
;          16:   water_strong_twoband_total_column
;          17:   water_total_column
;          18:   water_total_column_precision
;          19:   water_weak_twoband_total_column
;          20:   wavelength_calibration_offset
index=3
print,''

print,';--------------------------------;'
print,'    Extracting ', dname(index)
print,';--------------------------------;'

param5=param4+'/'+strtrim(dname(index),2)
d_id = H5D_OPEN(g4_id,param5)
height_scattering_layer=H5D_READ(d_id)

print,strtrim(dname(index),2),': max=',max(height_scattering_layer),', min=',min(height_scattering_layer)
help,height_scattering_layer
print,''
attr_num=H5A_GET_NUM_ATTRS(d_id)
for inum=0L,attr_num-1L do begin
 attr_id=H5A_OPEN_IDX(d_id,inum)
 attr_name=H5A_GET_NAME(attr_id)
 attr=H5A_READ(attr_id)
; print,'        ',attr_name,': ',attr
endfor
print,''

H5D_CLOSE,d_id
qa_value=0.01*qa_value
;index=where(carbonmonoxide_total_column ne 9.96921e+36 and qa_value eq 1.0)
;if index(0) ne -1 then carbonmonoxide_total_column(index)=carbonmonoxide_total_column(index)*6.02214e+19
;index=where(carbonmonoxide_total_column eq 9.96921e+36 or qa_value lt 1.0)
;if index(0) ne -1 then carbonmonoxide_total_column(index)=-999.
index=where(carbonmonoxide_total_column ne 9.96921e+36)
if index(0) ne -1 then carbonmonoxide_total_column(index)=carbonmonoxide_total_column(index)*6.02214e+19
index=where(carbonmonoxide_total_column eq 9.96921e+36)
if index(0) ne -1 then carbonmonoxide_total_column(index)=-999.

print,max(carbonmonoxide_total_column)
;        units: mol m-2
;        standard_name: atmosphere_mole_content_of_carbon_monoxide
;        long_name: Vertically integrated CO column
;        coordinates: longitude latitude
;        ancillary_variables: carbonmonoxide_total_column_precision
;        multiplication_factor_to_convert_to_molecules_percm2:   6.02214e+19
;        _FillValue:   9.96921e+36
;        units: 1
;        scale_factor:     0.0100000
;        add_offset:       0.00000
;        valid_min:    0
;        valid_max:  100
;        long_name: data quality value
;        comment: A continuous quality descriptor, varying between 0 (no data) and 1 (full quality data). Recommend to ignore data with qa_value < 0.5
;        coordinates: longitude latitude
;        _FillValue:  255
cocolumn=-999.+0.*carbonmonoxide_total_column
index=where(carbonmonoxide_total_column ne -999.)
cocolumn(index)=1.e-18*carbonmonoxide_total_column(index)
level=.5+5.5*findgen(31)/30.
color=icmm2*findgen(31)/30.
!p.font=1
!p.charsize=2.
help,cocolumn,longitude,latitude
contour,cocolumn,longitude,latitude,level=level,min_val=-999.,/cell_fill,c_colors=color,/overplot
endif
endfor
MAP_SET,0,180,0,/mollweide,/noborder,/continents,/grid,latdel=30.,/noeras,title='TropOMI Column Carbon Monoxide (10!u18!nmol/cm!u2!n) '+yyyymmdd,color=0

!p.thick=1
; color bar
!p.charsize=2.
        !psym=0
        imin=min(level)
        imax=max(level)
        set_viewport,.5,.9,.09,.1
        !type=2^2+2^3+2^6
        plot,[imin,imax],[0,0],yrange=[0,10],xrange=[imin,imax],$
        xtitle='(1e18 mol/cm!u2!n)',/noeras,color=0
        ybox=[0,10,10,0,0]
        x2=imin
        dx=(imax-imin)/float(icmm2)
        for j=0,icmm2-1 do begin
            xbox=[x2,x2,x2+dx,x2+dx,x2]
            polyfill,xbox,ybox,color=j
            x2=x2+dx
        endfor
if setplot eq 'Z' then begin
image=tvrd(0,0,win_nx,win_ny)
image_byt=bytscl(image,min=0,max=255)
;transparent=bytarr(256)+255B
;transparent(255:255)=0
tvlct,r,g,b,/get
write_png,'TROPOMI.column.CO.FIREX.20190722.mollweide.png',image_byt,r,g,b
endif
end
