; Specify window size
nxpix=1000L
nypix=1000L

SETPLOT='ps'
SETPLOT='Z'
;read,'setplot?',setplot

if setplot eq 'Z' then begin
;-------------------------------------------
set_plot,'Z'
device,set_resolution=[nxpix,nypix],z_buffer=0
win_nx=!d.x_size
win_ny=!d.y_size

;--------------------------------------------
; Insert the main script
;--------------------------------------------
endif
if SETPLOT eq 'ps' then set_plot,'ps'
; set color table
  loadct,39
  !p.background=254.
  !p.color=255.
mcolor=byte(!p.color)
mcolor=fix(mcolor)
if mcolor eq 0 then mcolor=255
col1=mcolor
icmm1=mcolor-1
icmm2=mcolor-2
if setplot eq 'x' then begin
   lc=mcolor
   window,4,xsize=nxdim,ysize=nydim
   device,retain=2,decomposed=0
endif
; Specify window size
nxdim=1000L
nydim=1000L
yyyymmdd='20190709'
if setplot eq 'ps' then begin
   lc=0
   set_plot,'ps'
   xsize=nxdim/100.
   ysize=nydim/100.
   !p.font=0
   device,/landscape,bits=8,filename='tropomi_column_hcho_'+yyyymmdd+'.ladco.ps'
   device,/color
   device,/inch,xoff=4.25-ysize/2.,yoff=5.5+xsize/2.,$
          xsize=xsize,ysize=ysize
   !p.charsize=1.
endif
!p.charsize=1
set_viewport,0,1,0,1
!type=2^5+2^6
plot,[0,1],[0,1],/nodata
polyfill,[0,1,1,0,0],[0,0,1,1,0],color=mcolor
set_viewport,.1,.9,.2,.9
;MAP_SET,0,180,0,/mollweide,/noborder,/continents,/grid,latdel=30.,/noeras
map_set,/us,/continents,limit=[41.5,-90,45,-85],/HIRES,/noeras
;
indir='/ships19/aqda/bpierce/Satellite/TROPOMI/HCHO/October_2019_download/LoRes/'
;
openr,1,'tropomi.hcho.fil'
nfiles=0l
readf,1,nfiles
for nf=0,nfiles-1 do begin
blank=''
readf,1,blank
; hcho result=str_sep(blank,'___')
result=str_sep(blank,'___')
syr=strmid(result(1),0,4)
smn=strmid(result(1),4,2)
sdy=strmid(result(1),6,2)
hrmnsc=strmid(result(1),9,6)
shr=strmid(hrmnsc,0,2)
smin=strmid(hrmnsc,2,2)
ssc=strmid(hrmnsc,4,2)
shr=shr+':'+smin+':'+ssc
;2011070118
year=long(syr)
month=long(smn)
day=long(sdy)
hour=long(hrmnsc)
print,blank
jday0=julday(1l,1l,year,0l,0l,0l)
jday=julday(month,day,year,0l,0l,0l)-jday0+1.
;print,jday
result=str_sep(string(jday),'.')
sjd=strtrim(result(0),2)
if jday lt 10 then sjd='00'+sjd
if jday lt 100 then sjd='0'+sjd
infile=blank
;
result=H5F_IS_HDF5(indir+infile)

if result eq 1 then begin

; Open HDF5-based file
file_id=H5F_OPEN(indir+infile)

;result=H5_BROWSER(infile)
;stop

;result=H5_PARSE(infile)
;help,result,/structure
;stop

;           0:   DETAILED_RESULTS
;           1:   GEOLOCATIONS
;           2:   INPUT_DATA
param4='/PRODUCT/'
g4_id = H5G_OPEN(file_id,param4)
dnum=H5G_GET_NMEMBERS(g4_id,param4)
;comment=H5G_GET_COMMENT(g4_id,param4)

dname=strarr(dnum)
for inum=0L,dnum-1L do begin
 dname(inum)=H5G_GET_MEMBER_NAME(g4_id,param4,inum)
; print,inum,':   ',dname(inum)
endfor
;           0:   SUPPORT_DATA
;           1:   corner
;           2:   delta_time
;           3:   formaldehyde_tropospheric_vertical_column
;           4:   formaldehyde_tropospheric_vertical_column_precision
;           5:   ground_pixel
;           6:   latitude
;           7:   layer
;           8:   longitude
;           9:   qa_value
;          10:   scanline
;          11:   time
;          12:   time_utc
;stop
index=6
print,''

print,';--------------------------------;'
print,'    Extracting ', dname(index)
print,';--------------------------------;'

param5=param4+'/'+strtrim(dname(index),2)
d_id = H5D_OPEN(g4_id,param5)
latitude=H5D_READ(d_id)

print,strtrim(dname(index),2),': max=',max(latitude),', min=',min(latitude)
help,latitude
print,''
attr_num=H5A_GET_NUM_ATTRS(d_id)
for inum=0L,attr_num-1L do begin
 attr_id=H5A_OPEN_IDX(d_id,inum)
 attr_name=H5A_GET_NAME(attr_id)
 attr=H5A_READ(attr_id)
; print,'        ',attr_name,': ',attr
endfor
print,''

H5D_CLOSE,d_id
index=8
print,''

print,';--------------------------------;'
print,'    Extracting ', dname(index)
print,';--------------------------------;'

param5=param4+'/'+strtrim(dname(index),2)
d_id = H5D_OPEN(g4_id,param5)
longitude=H5D_READ(d_id)

print,strtrim(dname(index),2),': max=',max(longitude),', min=',min(longitude)
help,longitude
print,''
attr_num=H5A_GET_NUM_ATTRS(d_id)
for inum=0L,attr_num-1L do begin
 attr_id=H5A_OPEN_IDX(d_id,inum)
 attr_name=H5A_GET_NAME(attr_id)
 attr=H5A_READ(attr_id)
; print,'        ',attr_name,': ',attr
endfor
print,''

H5D_CLOSE,d_id
;
; select overpass
;
; 41.5,-90,45,-85
gindex=where((latitude ge 41.5 and latitude le 45.) and (longitude ge -90. and longitude le -85.))
if gindex(0) eq -1 then goto, jumpout
index=3
print,''

print,';--------------------------------;'
print,'    Extracting ', dname(index)
print,';--------------------------------;'

param5=param4+'/'+strtrim(dname(index),2)
d_id = H5D_OPEN(g4_id,param5)
formaldehyde_tropospheric_vertical_column=H5D_READ(d_id)

print,strtrim(dname(index),2),': max=',max(formaldehyde_tropospheric_vertical_column),', min=',min(formaldehyde_tropospheric_vertical_column)
help,formaldehyde_tropospheric_vertical_column
print,''
attr_num=H5A_GET_NUM_ATTRS(d_id)
for inum=0L,attr_num-1L do begin
 attr_id=H5A_OPEN_IDX(d_id,inum)
 attr_name=H5A_GET_NAME(attr_id)
 attr=H5A_READ(attr_id)
 print,'        ',attr_name,': ',attr
endfor
print,''

H5D_CLOSE,d_id
index=9
print,''

print,';--------------------------------;'
print,'    Extracting ', dname(index)
print,';--------------------------------;'

param5=param4+'/'+strtrim(dname(index),2)
d_id = H5D_OPEN(g4_id,param5)
qa_value=H5D_READ(d_id)

print,strtrim(dname(index),2),': max=',max(qa_value),', min=',min(qa_value)
help,qa_value
print,''
attr_num=H5A_GET_NUM_ATTRS(d_id)
for inum=0L,attr_num-1L do begin
 attr_id=H5A_OPEN_IDX(d_id,inum)
 attr_name=H5A_GET_NAME(attr_id)
 attr=H5A_READ(attr_id)
 print,'        ',attr_name,': ',attr
endfor
print,''

H5D_CLOSE,d_id
param4='/PRODUCT/SUPPORT_DATA/DETAILED_RESULTS'
g4_id = H5G_OPEN(file_id,param4)
dnum=H5G_GET_NMEMBERS(g4_id,param4)
;comment=H5G_GET_COMMENT(g4_id,param4)

dname=strarr(dnum)
for inum=0L,dnum-1L do begin
 dname(inum)=H5G_GET_MEMBER_NAME(g4_id,param4,inum)
 print,inum,':   ',dname(inum)
endfor
;           0:   WAVELENGTH_CALIBRATIONS
;           1:   averaging_kernel
;           2:   cloud_fraction_intensity_weighted
;           3:   cloud_fraction_intensity_weighted_precision
;           4:   fitted_radiance_shift
;           5:   fitted_radiance_squeeze
;           6:   fitted_root_mean_square
;           7:   fitted_root_mean_square_win1
;           8:   fitted_slant_columns
;           9:   fitted_slant_columns_precision
;          10:   fitted_slant_columns_win1
;          11:   fitted_slant_columns_win1_precision
;          12:   formaldehyde_clear_air_mass_factor
;          13:   formaldehyde_cloudy_air_mass_factor
;          14:   formaldehyde_profile_apriori
;          15:   formaldehyde_slant_column_corrected
;          16:   formaldehyde_slant_column_corrected_trueness
;          17:   formaldehyde_slant_column_correction_flag
;          18:   formaldehyde_tropospheric_air_mass_factor
;          19:   formaldehyde_tropospheric_air_mass_factor_kernel_trueness
;          20:   formaldehyde_tropospheric_air_mass_factor_precision
;          21:   formaldehyde_tropospheric_air_mass_factor_trueness
;          22:   formaldehyde_tropospheric_vertical_column_correction
;          23:   formaldehyde_tropospheric_vertical_column_kernel_trueness
;          24:   formaldehyde_tropospheric_vertical_column_trueness
;          25:   number_of_iterations_in_retrieval
;          26:   number_of_iterations_in_retrieval_win1
;          27:   number_of_slant_columns
;          28:   number_of_slant_columns_first_win1
;          29:   number_of_spectral_points_in_retrieval
;          30:   number_of_spectral_points_in_retrieval_win1
;          31:   processing_quality_flags
;stop
index=2
print,''

print,';--------------------------------;'
print,'    Extracting ', dname(index)
print,';--------------------------------;'

param5=param4+'/'+strtrim(dname(index),2)
d_id = H5D_OPEN(g4_id,param5)
cloud_radiance_fraction=H5D_READ(d_id)

print,strtrim(dname(index),2),': max=',max(cloud_radiance_fraction),', min=',min(cloud_radiance_fraction)
help,cloud_radiance_fraction
print,''
attr_num=H5A_GET_NUM_ATTRS(d_id)
for inum=0L,attr_num-1L do begin
 attr_id=H5A_OPEN_IDX(d_id,inum)
 attr_name=H5A_GET_NAME(attr_id)
 attr=H5A_READ(attr_id)
; print,'        ',attr_name,': ',attr
endfor
print,''

H5D_CLOSE,d_id
index=where(formaldehyde_tropospheric_vertical_column ne 9.96921e+36 and cloud_radiance_fraction le .6 and qa_value ge 0.5)
index=where(formaldehyde_tropospheric_vertical_column ne 9.96921e+36)
if index(0) ne -1 then formaldehyde_tropospheric_vertical_column(index)=formaldehyde_tropospheric_vertical_column(index)*6.02214e+19
index=where(formaldehyde_tropospheric_vertical_column eq 9.96921e+36 or cloud_radiance_fraction gt .6 or qa_value lt 0.5)
index=where(formaldehyde_tropospheric_vertical_column eq 9.96921e+36)
if index(0) ne -1 then formaldehyde_tropospheric_vertical_column(index)=-999.
print,max(formaldehyde_tropospheric_vertical_column)
;        fill value 9.96921e+36
;        units: mol m-2
;        standard_name: troposphere_mole_content_of_nitrogen_dioxide
;        long_name: Tropospheric vertical column of nitrogen dioxide
;        coordinates: longitude latitude
;        ancillary_variables: 
;formaldehyde_tropospheric_vertical_column_precision air_mass_factor_troposphere air_mass_factor_total averaging_kernel
;        multiplication_factor_to_convert_to_molecules_percm2:   6.02214e+19
;
;
;        units: 1
;        scale_factor:     0.0100000
;        add_offset:       0.00000
;        valid_min:    0
;        valid_max:  100
;        long_name: data quality value
;        comment: 
;A continuous quality descriptor, varying between 0 (no data) and 1 (full quality data). Recommend to ignore data with qa_value < 0.5
;
hchocolumn=-999.+0.*formaldehyde_tropospheric_vertical_column
index=where(formaldehyde_tropospheric_vertical_column ne -999.)
hchocolumn(index)=1.e-15*formaldehyde_tropospheric_vertical_column(index)
print,max(hchocolumn(index)),min(hchocolumn(index))
level=-1.+2.*findgen(31)/30.
level=30.*findgen(31)/30.
color=icmm2*findgen(31)/30.
!p.font=1
!p.charsize=2.
contour,hchocolumn,longitude,latitude,level=level,min_val=-999.,/cell_fill,c_colors=color,/overplot
jumpout:
endif
endfor
;MAP_SET,0,180,0,/mollweide,/noborder,/continents,/grid,latdel=30.,/noeras,title='TropOMI Tropospheric NO2 (10!u15!nmol/cm!u2!n) '+yyyymmdd,color=0
map_set,/us,/continents,limit=[41.5,-90,45,-85],/HIRES,/noeras,title='TropOMI Tropospheric HCHO (10!u15!nmol/cm!u2!n) '+yyyymmdd,color=0
colors=mcolor+[0B,0B,0B]
       DrawCounties_white, 'co2000p020.shp', Statenames=['WI','MI','IL']

!p.thick=1
; color bar
!p.charsize=2.
        !psym=0
        imin=min(level)
        imax=max(level)
        set_viewport,.5,.9,.09,.1
        !type=2^2+2^3+2^6
        plot,[imin,imax],[0,0],yrange=[0,10],xrange=[imin,imax],$
        xtitle='1e15 mol/cm!u2!n',/noeras,color=0
        ybox=[0,10,10,0,0]
        x2=imin
        dx=(imax-imin)/float(icmm2)
        for j=0,icmm2-1 do begin
            xbox=[x2,x2,x2+dx,x2+dx,x2]
            polyfill,xbox,ybox,color=j
            x2=x2+dx
        endfor
if setplot eq 'Z' then begin
image=tvrd(0,0,win_nx,win_ny)
image_byt=bytscl(image,min=0,max=255)
;transparent=bytarr(256)+255B
;transparent(255:255)=0
tvlct,r,g,b,/get
write_png,'TROPOMI.column.HCHO.20190709.LADCO.cld.frac.0.6.qa.ge.0.5.png',image_byt,r,g,b
endif
end
